[issue1241] grml-live-remaster

Moritz Molle bts at bts.grml.org
Mon Mar 11 15:16:18 CET 2013


New submission from Moritz Molle <mmolle at gmx.net>:

hi,

i am creating a grml for my work (i base it on grml32-full, 2013.02),
where i don't really have to change much. so i tried to use
grml-live-remaster. actually a nice script (please leave it in! it's
easy to read, change, and does, kinda, what it's supposed to do.)

'kinda'. i.e. not really.

but i patched it, so it now works for me

with this mail, i'm sending you the patch, no © attached :)

what it does:

1. /remaster is created in a 'if' clause, i didn't really get why. so i
took it out of the if. also, i require the existence of /remaster
beforehand. so i can symlink it to a directory on a harddrive. (this was
good for me, could be possibly nicer for usability)

2. the squashfs-directory + filename is created wrong. (using basename),
i did it differently, which worked for grml32-full, probably working for
64 too, didn't test.

3. /run and /dev/pts aren't bind-mounted, i included that. important:
/dev/pts has to be mounted after /dev but unmounted before /dev. (that
one cost me 2 reboots), so in the 'for i in /dev /run ...' the list
cannot be the same.

4. filesystem.module is not created (needed for grml2usb), included that.

keep up the good work! thanks for a great distro.

mo

----------
files: grml-live-remaster, grml-live-remaster.orig, remaster.diff
messages: 4527
nosy: mmolle
status: unread
title: grml-live-remaster

_____________________________________
GRML issue tracker <bts at bts.grml.org>
<http://bts.grml.org/grml/issue1241>
_____________________________________
-------------- next part --------------
#!/bin/sh
# Filename:      grml-live-remaster
# Purpose:       remaster a grml from the live cd
# Authors:       grml-team (grml.org),
#                (c) Michael Schierl <schierlm at gmx.de>,
#                (c) Michael Prokop <mika at grml.org>,
#                (c) Thorsten Glaser <tg at mirbsd.org>
# Bug-Reports:   see http://grml.org/bugs/
# License:       This file is licensed under the GPL v2 or any later version.
################################################################################
# DISCLAIMER:
# this script currently lacks LOTS of error checking code... any help welcome...
################################################################################

# define function getfilesize before "set -e"
if stat --help >/dev/null 2>&1; then
  getfilesize='stat -c %s'      # GNU stat
else
  getfilesize='stat -f %z'      # BSD stat
fi

set -e # exit on any error
set -x # debugging

if [ -d /live/image/boot/ ] ; then # until Grml versions <=2012.XX
  LIVE_PATH_MAIN='/live/image'
  LIVE_PATH_BOOT='/live/image/boot/'
else # for Grml versions >=2013.XX
  LIVE_PATH_MAIN='/lib/live/mount/medium/'
  LIVE_PATH_BOOT='/lib/live/mount/medium/boot/'
fi

VERSION='0.0.3'
GRML_LIVE_EDITOR=${VISUAL:-${EDITOR:-nano}}

# source core functions {{{
if ! [ -r /etc/grml/lsb-functions ] || ! [ -r /etc/grml/script-functions ] ; then
  echo "Error: could not read /etc/grml/lsb-functions and/or /etc/grml/script-functions." >&2
  echo "Error: $0 can run only in Grml live session. Exiting." >&2
  exit 1
fi

. /etc/grml/lsb-functions
. /etc/grml/script-functions
# }}}

if ! isgrmlcd ; then
  echo "Error: $0 can run only in Grml live session. Exiting." >&2
  exit 1
fi

# make sure we have what we need {{{
if check4progs mkisofs >/dev/null 2>&1 ; then
  MKISO=mkisofs
fi

if check4progs genisoimage >/dev/null 2>&1 ; then
  MKISO=genisoimage
fi

if [ -z "$MKISO" ] ; then
  echo "Error: neither mkisofs nor genisoimage available. Exiting." >&2
  exit 1
fi

check4progs stat || exit 1

# allow overriding via environment:
if [ -z "$MKSQUASHFS" ] ; then
  if which mksquashfs >/dev/null 2>&1 ; then
    MKSQUASHFS=mksquashfs
  else
    echo "Error: mksquashfs is not available. Exiting." >&2
    exit 1
  fi
fi
check4root || exit 1
# }}}

if [ -z "$1" ]; then
   echo "$0 - version $VERSION

Usage: $0 destination.iso
  destination.iso should point to a path that is on a hard disk,
  you might want to mount some swap partitions or swap files
  first, because grml-live-remaster will need a lot ot RAM.

Please report bugs and feature requests: http://grml.org/bugs/" >&2
   exit 1
fi

if [ ! -d /remaster ]; then
	echo please create a /remaster, best link it to a harddrive.
	exit 1
fi
mkdir -p /remaster/chroot /remaster/tmp /remaster/cdrom
mount -t tmpfs tmpfs /remaster/tmp
echo "#:# edit the following two lines to change the boot message" \
        >/remaster/msg
echo "#:#" >>/remaster/msg
if [ -r ${LIVE_PATH_BOOT}/isolinux/boot.msg ] ; then
	sed 1,2d ${LIVE_PATH_BOOT}/isolinux/boot.msg >>/remaster/msg
fi

SQUASHFS_FILE="$(find ${LIVE_PATH_MAIN}/live -name \*.squashfs | head -1)"

if ! grep -q "/remaster/cdrom squashfs" /proc/mounts ;  then
   mount -t squashfs "$SQUASHFS_FILE" /remaster/cdrom -o ro,loop
fi

if ! grep -q "aufs /remaster/chroot" /proc/mounts ; then
   mount -t aufs aufs /remaster/chroot -o br:/remaster/tmp=rw:/remaster/cdrom=rr
fi

for i in run dev dev/pts proc root sys tmp; do
    mount --bind /$i /remaster/chroot/$i
done

echo "Now edit the contents of the live CD in this chrooted shell:"
chroot /remaster/chroot

for i in run dev/pts dev proc root sys tmp; do
        umount /remaster/chroot/$i
done

${GRML_LIVE_EDITOR} /remaster/msg

[ -d /remaster/iso ] || mkdir /remaster/iso

for i in ${LIVE_PATH_MAIN}/*; do
    if [ ! $i = ${LIVE_PATH_MAIN}/live ]; then
       cp -R $i /remaster/iso
    fi
done

if [ -r /remaster/iso/boot/isolinux/boot.msg ] ; then
   rm /remaster/iso/boot/isolinux/boot.msg
fi

# make sure we support usb sticks as well:
if [ -d ${LIVE_PATH_BOOT}/isolinux ] ; then
   BOOTSTUFF=${LIVE_PATH_BOOT}/isolinux
else
   BOOTSTUFF=${LIVE_PATH_MAIN}
fi

[ -d /remaster/iso/boot/isolinux ] || mkdir -p /remaster/iso/boot/isolinux

sed 3,4d "${BOOTSTUFF}"/boot.msg \
        >/remaster/iso/boot/isolinux/boot.msg
sed 1,2d /remaster/msg >>/remaster/iso/boot/isolinux/boot.msg

SQUASHFS_FQNAME=/remaster/iso/${SQUASHFS_FILE##$LIVE_PATH_MAIN}
mkdir -p $(dirname $SQUASHFS_FQNAME)
# the next line is necessary for grml2usb to work on the destination image
cat $(basename $SQUASHFS_FQNAME) > $(dirname $SQUASHFS_FQNAME)/filesystem.module
$MKSQUASHFS /remaster/chroot $SQUASHFS_FQNAME
umount /remaster/chroot /remaster/cdrom

if [ -f /remaster/iso/boot/isolinux/isolinux.bin ] ; then
   ISOLINUX=boot/isolinux/isolinux.bin
   ISOLINUX_BOOTCAT=boot/isolinux/boot.cat
else
   ISOLINUX=isolinux.bin
   ISOLINUX_BOOTCAT=boot.cat
fi

$MKISO -b $ISOLINUX -no-emul-boot -c $ISOLINUX_BOOTCAT \
        -boot-info-table -boot-load-size 4 -no-pad \
        -l -r -J -o "$1" /remaster/iso
# pad for partition table
siz=$($getfilesize "$1")
cyls=$((siz / 512 / 32 / 16 + 1))       # C=$cyls H=16 S=32 (= 256 KiB units)
siz=$((cyls * 16 * 32 * 512))           # size after padding
dd if=/dev/zero bs=1 count=1 seek=$((siz - 1)) of="$1" 2>/dev/null
rm -R /remaster/iso

# here is the place where we could apply bootgrub.mksh

echo ""
echo "ISO generation complete:"
ls --color -l "$1"
echo "If you want to customize your ISO, just call grml-live-remaster again."

## END OF FILE #################################################################
# vim: ai filetype=sh expandtab
-------------- next part --------------
#!/bin/sh
# Filename:      grml-live-remaster
# Purpose:       remaster a grml from the live cd
# Authors:       grml-team (grml.org),
#                (c) Michael Schierl <schierlm at gmx.de>,
#                (c) Michael Prokop <mika at grml.org>,
#                (c) Thorsten Glaser <tg at mirbsd.org>
# Bug-Reports:   see http://grml.org/bugs/
# License:       This file is licensed under the GPL v2 or any later version.
################################################################################
# DISCLAIMER:
# this script currently lacks LOTS of error checking code... any help welcome...
################################################################################

# define function getfilesize before "set -e"
if stat --help >/dev/null 2>&1; then
  getfilesize='stat -c %s'      # GNU stat
else
  getfilesize='stat -f %z'      # BSD stat
fi

set -e # exit on any error

if [ -d /live/image/boot/ ] ; then # until Grml versions <=2012.XX
  LIVE_PATH_MAIN='/live/image'
  LIVE_PATH_BOOT='/live/image/boot/'
else # for Grml versions >=2013.XX
  LIVE_PATH_MAIN='/lib/live/mount/medium/'
  LIVE_PATH_BOOT='/lib/live/mount/medium/boot/'
fi

VERSION='0.0.3'
GRML_LIVE_EDITOR=${VISUAL:-${EDITOR:-vi}}

# source core functions {{{
if ! [ -r /etc/grml/lsb-functions ] || ! [ -r /etc/grml/script-functions ] ; then
  echo "Error: could not read /etc/grml/lsb-functions and/or /etc/grml/script-functions." >&2
  echo "Error: $0 can run only in Grml live session. Exiting." >&2
  exit 1
fi

. /etc/grml/lsb-functions
. /etc/grml/script-functions
# }}}

if ! isgrmlcd ; then
  echo "Error: $0 can run only in Grml live session. Exiting." >&2
  exit 1
fi

# make sure we have what we need {{{
if check4progs mkisofs >/dev/null 2>&1 ; then
  MKISO=mkisofs
fi

if check4progs genisoimage >/dev/null 2>&1 ; then
  MKISO=genisoimage
fi

if [ -z "$MKISO" ] ; then
  echo "Error: neither mkisofs nor genisoimage available. Exiting." >&2
  exit 1
fi

check4progs stat || exit 1

# allow overriding via environment:
if [ -z "$MKSQUASHFS" ] ; then
  if which mksquashfs >/dev/null 2>&1 ; then
    MKSQUASHFS=mksquashfs
  else
    echo "Error: mksquashfs is not available. Exiting." >&2
    exit 1
  fi
fi
check4root || exit 1
# }}}

if [ -z "$1" ]; then
   echo "$0 - version $VERSION

Usage: $0 destination.iso
  destination.iso should point to a path that is on a hard disk,
  you might want to mount some swap partitions or swap files
  first, because grml-live-remaster will need a lot ot RAM.

Please report bugs and feature requests: http://grml.org/bugs/" >&2
   exit 1
fi

if [ ! -d /remaster ]; then
   mkdir -p /remaster/chroot /remaster/tmp /remaster/cdrom
   mount -t tmpfs tmpfs /remaster/tmp
   echo "#:# edit the following two lines to change the boot message" \
           >/remaster/msg
   echo "#:#" >>/remaster/msg
   if [ -r ${LIVE_PATH_BOOT}/isolinux/boot.msg ] ; then
     sed 1,2d ${LIVE_PATH_BOOT}/isolinux/boot.msg >>/remaster/msg
   fi
fi

SQUASHFS_FILE="$(find ${LIVE_PATH_MAIN}/live -name \*.squashfs | head -1)"
if ! grep -q "/remaster/cdrom squashfs" /proc/mounts ;  then
   mount -t squashfs "$SQUASHFS_FILE" /remaster/cdrom -o ro,loop
fi

if ! grep -q "aufs /remaster/chroot" /proc/mounts ; then
   mount -t aufs aufs /remaster/chroot -o br:/remaster/tmp=rw:/remaster/cdrom=rr
fi

for i in dev proc root sys tmp; do
    mount --bind /$i /remaster/chroot/$i
done

echo "Now edit the contents of the live CD in this chrooted shell:"
chroot /remaster/chroot

for i in dev proc root sys tmp; do
        umount /remaster/chroot/$i
done

${GRML_LIVE_EDITOR} /remaster/msg

[ -d /remaster/iso ] || mkdir /remaster/iso

for i in ${LIVE_PATH_MAIN}/*; do
    if [ ! $i = ${LIVE_PATH_MAIN}/live ]; then
       cp -R $i /remaster/iso
    fi
done

if [ -r /remaster/iso/boot/isolinux/boot.msg ] ; then
   rm /remaster/iso/boot/isolinux/boot.msg
fi

# make sure we support usb sticks as well:
if [ -d ${LIVE_PATH_BOOT}/isolinux ] ; then
   BOOTSTUFF=${LIVE_PATH_BOOT}/isolinux
else
   BOOTSTUFF=${LIVE_PATH_MAIN}
fi

[ -d /remaster/iso/boot/isolinux ] || mkdir -p /remaster/iso/boot/isolinux

sed 3,4d "${BOOTSTUFF}"/boot.msg \
        >/remaster/iso/boot/isolinux/boot.msg
sed 1,2d /remaster/msg >>/remaster/iso/boot/isolinux/boot.msg

mkdir /remaster/iso/live
$MKSQUASHFS /remaster/chroot /remaster/iso/live/"$(basename $SQUASHFS_FILE)"
umount /remaster/chroot /remaster/cdrom

if [ -f /remaster/iso/boot/isolinux/isolinux.bin ] ; then
   ISOLINUX=boot/isolinux/isolinux.bin
   ISOLINUX_BOOTCAT=boot/isolinux/boot.cat
else
   ISOLINUX=isolinux.bin
   ISOLINUX_BOOTCAT=boot.cat
fi

$MKISO -b $ISOLINUX -no-emul-boot -c $ISOLINUX_BOOTCAT \
        -boot-info-table -boot-load-size 4 -no-pad \
        -l -r -J -o "$1" /remaster/iso
# pad for partition table
siz=$($getfilesize "$1")
cyls=$((siz / 512 / 32 / 16 + 1))       # C=$cyls H=16 S=32 (= 256 KiB units)
siz=$((cyls * 16 * 32 * 512))           # size after padding
dd if=/dev/zero bs=1 count=1 seek=$((siz - 1)) of="$1" 2>/dev/null
rm -R /remaster/iso

# here is the place where we could apply bootgrub.mksh

echo ""
echo "ISO generation complete:"
ls --color -l "$1"
echo "If you want to customize your ISO, just call grml-live-remaster again."

## END OF FILE #################################################################
# vim: ai filetype=sh expandtab
-------------- next part --------------
A non-text attachment was scrubbed...
Name: remaster.diff
Type: text/x-patch
Size: 1578 bytes
Desc: not available
URL: <http://ml.grml.org/pipermail/bugs-changes/attachments/20130311/dfb77d22/attachment-0001.bin>


More information about the Bugs-changes mailing list